﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Telerik.Windows.Controls;

namespace AppointmentsCustomInfo
{
    public class SampleAppointmentSource : AppointmentSource
    {
        public SampleAppointmentSource()
        {
            this.AllAppointments.Clear();
            this.AllAppointments.Add(new SampleAppointment()
            {
                StartDate = DateTime.Now,
                EndDate = DateTime.Now.AddHours(1),
                Subject = "Today Appointment 1",
                MyCustomAppointmentInfo = "info 1",
                Details = "Some Long Details are coming here",
                Location = "My Home Town"
            });

            this.AllAppointments.Add(new SampleAppointment()
            {
                StartDate = DateTime.Now.AddMinutes(30),
                EndDate = DateTime.Now.AddHours(1),
                Subject = "Today Appointment 2",
                MyCustomAppointmentInfo = "info 2",
                Details = "Some Long Details are coming here",
                Location = "Paris"
            });

            this.AllAppointments.Add(new SampleAppointment()
            {
                StartDate = DateTime.Now.AddMinutes(30),
                EndDate = DateTime.Now.AddHours(1),
                Subject = "Today Appointment 3",
                MyCustomAppointmentInfo = "info 3",
                Details = "Some Long Details are coming here",
                Location = "London"

            });

            this.AllAppointments.Add(new SampleAppointment()
            {
                StartDate = DateTime.Now.AddHours(2),
                EndDate = DateTime.Now.AddHours(3),
                Subject = "Today Appointment 4",
                MyCustomAppointmentInfo = "info 4",
                Details = "Some Long Details are coming here",
                Location = "Berlin"
            });

            this.AllAppointments.Add(new SampleAppointment()
            {
                StartDate = DateTime.Now.AddDays(1),
                EndDate = DateTime.Now.AddDays(1).AddHours(1),
                Subject = "Check Game scores",
                MyCustomAppointmentInfo = "info 5",
                Details = "Some Long Details are coming here",
                Location = "Redmond"
            });
            this.AllAppointments.Add(new SampleAppointment()
            {
                StartDate = DateTime.Now.AddDays(1),
                EndDate = DateTime.Now.AddDays(3),
                Subject = "Long run",
                MyCustomAppointmentInfo = "info 6",
                Details = "Some Long Details are coming here",
                Location = "Seattle"
            });
            this.AllAppointments.Add(new SampleAppointment()
            {
                StartDate = DateTime.Now.Date.AddDays(6),
                EndDate = DateTime.Now.Date.AddDays(7),
                Subject = "Long run",
                MyCustomAppointmentInfo = "info 7",
                Details = "Some Long Details are coming here",
                Location = "Honolulu"
            });

            this.OnDataLoaded();
        }

        public override void FetchData(DateTime startDate, DateTime endDate)
        {
            this.OnDataLoaded();
        }
    }

    public class SampleAppointment : IAppointment
    {
        /// <summary>
        /// Gets the subject of the appointment.
        /// </summary>
        public string Subject
        {
            get;
            set;
        }

        /// <summary>
        /// Gets the start date and time of the appointment.
        /// </summary>
        public DateTime StartDate
        {
            get;
            set;
        }

        /// <summary>
        /// Gets the end date and time of the appointment.
        /// </summary>
        public DateTime EndDate
        {
            get;
            set;
        }

        /// <summary>
        /// Gets the details of the appointment.
        /// </summary>
        public string Details
        {
            get;
            set;
        }

        /// <summary>
        /// Gets the location of the appointment.
        /// </summary>
        public string Location
        {
            get;
            set;
        }

        public string MyCustomAppointmentInfo
        {
            get;
            set;
        }
    }
}
